package com.android.NetworkGps;

import android.app.PendingIntent;
import android.app.PendingIntent.CanceledException;
import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;

public class MyLocationManager {

	private final static int CHECK_POSITION_INTERVAL = 60 * 1000;
	
	private LocationManager locationManager;
	
	private Context mContext;
	
	private Handler mHandler;
	
	private myListen myListenGPS;
	
	private myListen myListenNetwork;
	
	
	
	public MyLocationManager(Context context, Handler handler)
	{
		mContext = context;
		
		mHandler = handler;
		
		locationManager=(LocationManager)context.getSystemService(context.LOCATION_SERVICE);
	}
	

	 public boolean getGPSState()
	 {
    	ContentResolver resolver = mContext.getContentResolver();
        boolean open = Settings.Secure.isLocationProviderEnabled(resolver, LocationManager.GPS_PROVIDER);
        
        return open;
	 }
	   
	 
	 public void  toggleGPS() {

		Intent gpsIntent = new Intent();
		gpsIntent.setClassName("com.android.settings",
				"com.android.settings.widget.SettingsAppWidgetProvider");
		gpsIntent.addCategory("android.intent.category.ALTERNATIVE");
		gpsIntent.setData(Uri.parse("custom:3"));
		
		try {
			PendingIntent.getBroadcast(mContext, 0, gpsIntent, 0).send();
		} catch (CanceledException e) {
			e.printStackTrace();
		}
	}
	
	
	 
	public Location getLocationByGps()
	{
		Location  location = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
		
		return location;
	}
	
	public Location getLocationByNetwork()
	{
		Location  location = locationManager.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);

		return location;
	}
	 
	
	public void registerListen()
	{
		if (myListenGPS == null)
		{
			myListenGPS = new myListen();
			
			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
					CHECK_POSITION_INTERVAL, 0, myListenGPS);
			
			
		}
		
		if (myListenNetwork == null)
		{
			myListenNetwork = new myListen();
			
			locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER,
					CHECK_POSITION_INTERVAL, 0, myListenNetwork);
		}
	}
	
	public void unRegisterListen()
	{
		if(myListenGPS != null)
		{
			locationManager.removeUpdates(myListenGPS);
			
			myListenGPS = null;
			
		}
		
		if(myListenNetwork != null)
		{
			locationManager.removeUpdates(myListenNetwork);
			
			myListenNetwork = null;
			
		}
	}
	
	
	class myListen implements LocationListener
	{

		@Override
		public void onLocationChanged(Location location) {
			// TODO Auto-generated method stub
			
			MyUtil.display("onLocationChanged.......");

			
			if (mHandler != null)
			{
				Message msg = mHandler.obtainMessage(NetworkGpsActivity.REFRESH_LOCATION, location);
				msg.sendToTarget();
			}
		}

		@Override
		public void onProviderDisabled(String provider) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void onProviderEnabled(String provider) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void onStatusChanged(String provider, int status, Bundle extras) {
			// TODO Auto-generated method stub
			
		}
		
	}
}
